"""
   User wrapper around fileobject
"""


class FileBase:

        ok_file_methods = ('fileno', 'flush', 'isatty', 'read', 'readline',
                'readlines', 'seek', 'tell', 'write', 'writelines')


class FileWrapper(FileBase):

        def __init__(self, f):
                self.f = f
                for m in self.ok_file_methods:
                        if not hasattr(self, m) and hasattr(f, m):
                                setattr(self, m, getattr(f, m))

        def close(self):
                self.flush()


TEMPLATE = """
def %s(self, *args):
        return apply(getattr(self.mod, self.name).%s, args)
"""

class FileDelegate(FileBase):

        def __init__(self, mod, name):
                self.mod = mod
                self.name = name

        for m in FileBase.ok_file_methods + ('close',):
                exec TEMPLATE % (m, m)
